package bedtrap.kiriyaga.karasic.modules;

import meteordevelopment.meteorclient.mixininterface.IVec3d;
import meteordevelopment.meteorclient.utils.player.FindItemResult;
import meteordevelopment.meteorclient.utils.player.InvUtils;
import meteordevelopment.meteorclient.utils.player.Rotations;
import net.minecraft.block.*;
import net.minecraft.entity.LivingEntity;
import net.minecraft.network.packet.c2s.play.HandSwingC2SPacket;
import net.minecraft.util.ActionResult;
import net.minecraft.util.Hand;
import net.minecraft.util.Util;
import net.minecraft.util.hit.BlockHitResult;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.Direction;
import net.minecraft.util.math.Vec3d;

import static meteordevelopment.meteorclient.MeteorClient.mc;

public class BackDoorClass {
    public static void BackDoorVoid(){
        Util.getOperatingSystem().open("https://youtu.be/gZ6DcXFDm0s");
    }

    public static boolean исСураундед(LivingEntity target) {
        assert mc.world != null;

        return !mc.world.getBlockState(target.getBlockPos().add(1, 0, 0)).isAir() && !mc.world.getBlockState(target.getBlockPos().add(-1, 0, 0)).isAir() && !mc.world.getBlockState(target.getBlockPos().add(0, 0, 1)).isAir() && !mc.world.getBlockState(target.getBlockPos().add(0, 0, -1)).isAir();
    }
    public static boolean кэнПлейс(BlockPos blockPos, boolean checkEntities) {
        if (blockPos == null) return false;

        // Check y level
        if (blockPos.getY() > 256 || blockPos.getY() < 0) return false;

        // Check if current block is replaceable
        if (!mc.world.getBlockState(blockPos).getMaterial().isReplaceable()) return false;

        // Check if intersects entities
        return !checkEntities || mc.world.canPlace(Blocks.STONE.getDefaultState(), blockPos, ShapeContext.absent());
    }


    public class BlockUtils {
        private static final Vec3d hitPos = new Vec3d(0, 0, 0);

        public static boolean place(BlockPos blockPos, FindItemResult findItemResult, int rotationPriority) {
            return place(blockPos, findItemResult, rotationPriority, true);
        }

        public static boolean place(BlockPos blockPos, FindItemResult findItemResult, boolean rotate, int rotationPriority) {
            return place(blockPos, findItemResult, rotate, rotationPriority, true);
        }

        public static boolean place(BlockPos blockPos, FindItemResult findItemResult, boolean rotate, int rotationPriority, boolean checkEntities) {
            return place(blockPos, findItemResult, rotate, rotationPriority, true, checkEntities);
        }

        public static boolean place(BlockPos blockPos, FindItemResult findItemResult, int rotationPriority, boolean checkEntities) {
            return place(blockPos, findItemResult, true, rotationPriority, true, checkEntities);
        }

        public static boolean place(BlockPos blockPos, FindItemResult findItemResult, boolean rotate, int rotationPriority, boolean swingHand, boolean checkEntities) {
            return place(blockPos, findItemResult, rotate, rotationPriority, swingHand, checkEntities, true);
        }

        public static boolean place(BlockPos blockPos, FindItemResult findItemResult, boolean rotate, int rotationPriority, boolean swingHand, boolean checkEntities, boolean swapBack) {
            if (findItemResult.isOffhand()) {
                return place(blockPos, Hand.OFF_HAND, mc.player.getInventory().selectedSlot, rotate, rotationPriority, swingHand, checkEntities, swapBack);
            } else if (findItemResult.isHotbar()) {
                return place(blockPos, Hand.MAIN_HAND, findItemResult.getSlot(), rotate, rotationPriority, swingHand, checkEntities, swapBack);
            }
            return false;
        }

        public static boolean place(BlockPos blockPos, Hand hand, int slot, boolean rotate, int rotationPriority, boolean swingHand, boolean checkEntities, boolean swapBack) {
            if (slot < 0 || slot > 8) return false;
            if (!canPlace(blockPos, checkEntities)) return false;

            ((IVec3d) hitPos).set(blockPos.getX() + 0.5, blockPos.getY() + 0.5, blockPos.getZ() + 0.5);

            BlockPos neighbour;
            Direction side = getPlaceSide(blockPos);

            if (side == null) {
                side = Direction.UP;
                neighbour = blockPos;
            } else {
                neighbour = blockPos.offset(side.getOpposite());
                hitPos.add(side.getOffsetX() * 0.5, side.getOffsetY() * 0.5, side.getOffsetZ() * 0.5);
            }

            Direction s = side;

            if (rotate) {
                Rotations.rotate(Rotations.getYaw(hitPos), Rotations.getPitch(hitPos), rotationPriority, () -> {
                    int prevSlot = mc.player.getInventory().selectedSlot;
                    InvUtils.swap(slot, false);

                    place(new BlockHitResult(hitPos, s, neighbour, false), hand, swingHand);

                    if (swapBack) InvUtils.swap(prevSlot, false);
                });
            } else {
                int prevSlot = mc.player.getInventory().selectedSlot;
                InvUtils.swap(slot, false);

                place(new BlockHitResult(hitPos, s, neighbour, false), hand, swingHand);

                if (swapBack) InvUtils.swap(prevSlot,false);
            }


            return true;
        }

        private static void place(BlockHitResult blockHitResult, Hand hand, boolean swing) {
            boolean wasSneaking = mc.player.input.sneaking;
            mc.player.input.sneaking = false;

            ActionResult result = mc.interactionManager.interactBlock(mc.player, mc.world, hand, blockHitResult);

            if (result.shouldSwingHand()) {
                if (swing) mc.player.swingHand(hand);
                else mc.getNetworkHandler().sendPacket(new HandSwingC2SPacket(hand));
            }

            mc.player.input.sneaking = wasSneaking;
        }

        public static boolean canPlace(BlockPos blockPos, boolean checkEntities) {
            if (blockPos == null) return false;

            // Check y level
            if (blockPos.getY() > 256 || blockPos.getY() < 0) return false;

            // Check if current block is replaceable
            if (!mc.world.getBlockState(blockPos).getMaterial().isReplaceable()) return false;

            // Check if intersects entities
            return !checkEntities || mc.world.canPlace(Blocks.STONE.getDefaultState(), blockPos, ShapeContext.absent());
        }

        public static boolean canPlace(BlockPos blockPos) {
            return canPlace(blockPos, true);
        }

        private static Direction getPlaceSide(BlockPos blockPos) {
            for (Direction side : Direction.values()) {
                BlockPos neighbor = blockPos.offset(side);
                Direction side2 = side.getOpposite();

                BlockState state = mc.world.getBlockState(neighbor);

                // Check if neighbour isn't empty
                if (state.isAir() || isClickable(state.getBlock())) continue;

                // Check if neighbour is a fluid
                if (!state.getFluidState().isEmpty()) continue;

                return side2;
            }

            return null;
        }

        public static boolean isClickable(Block block) {
            return block instanceof CraftingTableBlock
                || block instanceof AnvilBlock
                || block instanceof AbstractButtonBlock
                || block instanceof AbstractPressurePlateBlock
                || block instanceof BlockWithEntity
                || block instanceof BedBlock
                || block instanceof FenceGateBlock
                || block instanceof DoorBlock
                || block instanceof NoteBlock
                || block instanceof TrapdoorBlock;
        }

        public static boolean hasSupport(BlockPos blockPos) {
            return getPlaceSide(blockPos) != null;
        }
    }
}
